SuperStrict

Rem 
bbdoc: Serialization / Deserialization Extended
about: This module adds functionality to the basic fscom.serialization library
End Rem
Module fscom.serializationex

ModuleInfo "Version: 0.2"
ModuleInfo "Author: Francesco Silvani"
ModuleInfo "License: zlib/libpng"

ModuleInfo "History: 0.2"
ModuleInfo "History: ..."


Import brl.bankstream
Import fscom.serialization

Rem
bbdoc: Serialize an object to a byte array
End Rem
Function SerializeObject:Byte[](obj:Object)
	'Allocate hopefully enough space for serialization
	Local bank:TBank = TBank.Create( (SizeOf obj) * 2)
	Local bankstream:TBankStream = TBankStream.Create(bank)
	StreamSerializeObject(obj , bankstream)
	Local size:Int = bankstream.Pos()
	Local bytes:Byte[] = New Byte[size]
	bankstream.Seek 0
	bankstream.Read bytes , size
	bankstream.Close()
	Return bytes
End Function

Rem
bbdoc: Deserialize an object from a byte array
End Rem
Function DeserializeObject:Object(bytes:Byte[])
	Local bank:TBank = TBank.Create(bytes.length)
	Local bankstream:TBankStream	 = TBankStream.Create(bank)
	bankstream.Write bytes , bytes.length
	bankstream.Seek 0
	Local obj:Object = StreamDeserializeObject(bankstream)
	bankstream.Close
	Return obj
End Function

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private

''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''

New TBankObjectFacory
Type TBankObjectFacory Extends TObjectFactory
	Global BankTypeId:TTypeId=TTypeId.ForName("TBank")
	
	Method Serialize:Byte(obj:Object , typeId:TTypeId , stream:TStream , koTree:TKnownObjectTree)
		If typeId = BankTypeId
			Local id:Int = koTree.Find(obj)
			If id < 0
				id = koTree.Insert(obj)
				stream.WriteInt(id)
				
				Local bank:TBank = TBank(obj)
				Local size:Int = bank.Size()

				stream.WriteInt(size)
				
				Local pos:Int = 0
				Local buf:Byte Ptr=bank.Buf()
				While pos<size
					pos:+ stream.Write(buf + pos , size - pos)
				Wend
			Else
				stream.WriteInt(id)
			EndIf
			Return True
		End If
	End Method

	Method Deserialize:Object(typeId:TTypeId , stream:TStream , koTree:TKnownObjectTree)
		If typeId = BankTypeId
			Local id:Int = stream.ReadInt()
			Local obj:TBank = TBank(koTree.Get(id))
			If obj
				Return obj
			Else
				If id<>koTree.size Throw "Serialize / Deserialize KnownObjectTree out of sync"
			EndIf
			
			Local size:Int = stream.ReadInt()
			obj = TBank.Create(size)			
			Local buf:Byte Ptr = obj.Buf()
			Local pos:Int=0
			
			While pos<size
				pos:+ stream.Read(buf + pos , size - pos)
			Wend 
			
			koTree.Insert(obj)
			Return obj
		End If
	End Method
End Type
